%global         debug_package   %{nil}

Name:           kcptun
Version:        20240919
Release:        1%{?dist}
Summary:        A Stable & Secure Tunnel based on KCP with N:M multiplexing and FEC

License:        MIT
URL:            https://github.com/xtaci/kcptun
Source0:        https://github.com/xtaci/kcptun/archive/refs/tags/v%{version}.tar.gz#/kcptun-%{version}.tar.gz

%if 0%{?rhel} && 0%{?rhel} < 8
BuildRequires:  systemd
%else
BuildRequires:  systemd-rpm-macros
%endif
%{?systemd_requires}
# BuildRequires:  golang >= 1.22

%description
A Stable & Secure Tunnel based on KCP with N:M multiplexing and FEC

%prep
%setup -q -n %{name}-%{version}

%build
LDFLAGS='-X main.VERSION=%{version} -s -w -buildid='
env CGO_ENABLED=0 go build -v -trimpath -ldflags "$LDFLAGS" -o %{name}-server ./server
env CGO_ENABLED=0 go build -v -trimpath -ldflags "$LDFLAGS" -o %{name}-client ./client

%install
%{__install} -d %{buildroot}%{_bindir}
%{__install} -p -m 755 %{name}-server %{buildroot}%{_bindir}
%{__install} -p -m 755 %{name}-client %{buildroot}%{_bindir}

%{__install} -d %{buildroot}%{_sysconfdir}/%{name}
%{__install} -p -m 644 dist/server.json.example %{buildroot}%{_sysconfdir}/%{name}/server.json
%{__install} -p -m 644 dist/local.json.example %{buildroot}%{_sysconfdir}/%{name}/client.json

%{__install} -d %{buildroot}%{_unitdir}
cat > %{buildroot}%{_unitdir}/%{name}-server.service <<EOF
[Unit]
Description=kcptun-server
Wants=network.target
After=syslog.target network-online.target
ConditionFileIsExecutable=/usr/bin/kcptun-server
ConditionPathExists=/etc/kcptun/server.json

[Service]
Type=simple
Environment=GOGC=20
ExecStart=/usr/bin/kcptun-server -c /etc/kcptun/server.json
Restart=on-failure
RestartSec=10
KillMode=process
LimitNOFILE=65536

[Install]
WantedBy=multi-user.target
EOF

cat > %{buildroot}%{_unitdir}/%{name}-client.service <<EOF
[Unit]
Description=kcptun-client
After=syslog.target network-online.target
ConditionFileIsExecutable=/usr/bin/kcptun-client
ConditionPathExists=/etc/kcptun/client.json

[Service]
Type=simple
Environment=GOGC=20
ExecStart=/usr/bin/kcptun-client -c /etc/kcptun/client.json
Restart=on-failure
RestartSec=10
KillMode=process
LimitNOFILE=65536

[Install]
WantedBy=multi-user.target
EOF

%post
%systemd_post %{name}-server.service
%systemd_post %{name}-client.service

%preun
%systemd_preun %{name}-server.service
%systemd_preun %{name}-client.service

%postun
%systemd_postun_with_restart %{name}-server.service
%systemd_postun_with_restart %{name}-client.service

%files
%defattr(-,root,root,-)
%{_bindir}/%{name}-server
%{_bindir}/%{name}-client
%config(noreplace) %{_sysconfdir}/%{name}/server.json
%config(noreplace) %{_sysconfdir}/%{name}/client.json
%{_unitdir}/%{name}-server.service
%{_unitdir}/%{name}-client.service
%license LICENSE.md
%doc README.md

%changelog
* Thu Sep 19 2024 Teddysun <i@teddysun.com> - 20240919-1
- Update version to 20240919

* Sat Sep 07 2024 Teddysun <i@teddysun.com> - 20240906-1
- Update version to 20240906

* Sat Aug 31 2024 Teddysun <i@teddysun.com> - 20240831-1
- Update version to 20240831

* Wed Aug 28 2024 Teddysun <i@teddysun.com> - 20240828-1
- Update version to 20240828

* Sun Aug 25 2024 Teddysun <i@teddysun.com> - 20240825-1
- Update version to 20240825

* Wed Aug 07 2024 Teddysun <i@teddysun.com> - 20240807-1
- Update version to 20240807

* Tue Jul 30 2024 Teddysun <i@teddysun.com> - 20240730-1
- Update version to 20240730

* Tue Jul 16 2024 Teddysun <i@teddysun.com> - 20240716-1
- Update version to 20240716

* Sat Jul 13 2024 Teddysun <i@teddysun.com> - 20240713-1
- Update version to 20240713

* Sun Jul 07 2024 Teddysun <i@teddysun.com> - 20240706-1
- Update version to 20240706

* Wed Jul 03 2024 Teddysun <i@teddysun.com> - 20240703-1
- Update version to 20240703

* Tue Jul 02 2024 Teddysun <i@teddysun.com> - 20240702-1
- Update version to 20240702

* Mon Jul 01 2024 Teddysun <i@teddysun.com> - 20240701-1
- Update version to 20240701

* Sun Jan 07 2024 Teddysun <i@teddysun.com> - 20240107-1
- Update version to 20240107

* Wed Oct 18 2023 Teddysun <i@teddysun.com> - 20231012-1
- Update version to 20231012
